<?php

$it = __('ipernity error message was “%s”', 'iperss');
$itemerror = __('Unknown item given. Please check if you entered the item correctly.', 'iperss');
$typeerror = __('Unknown type ID given. Please see types help.', 'iperss');
$noitemerror = __('No item given. Please check configuration', 'iperss');
$unhandlederror = __('An unhandled error occured. Please contact plugin author at given mail address', 'iperss');
$poweredbylink = __('powered by ipeRSS', 'iperss');


if (!function_exists('gettn')) {
	function gettn($item, $imgsize) {
		if ($imgsize == 't') {
			$tn = $item->get_enclosure()->get_thumbnail(1);
			return str_replace('.100.jpg', '.t.jpg', $tn);
		}
		if ($imgsize == 100) {
			return $item->get_enclosure()->get_thumbnail(1);
		}
		if ($imgsize == 240) {
			return $item->get_enclosure()->get_thumbnail(0);
		}
		if ($imgsize == 1024) {
			return $item->get_enclosure()->get_link();
		}
	}
}

if (!function_exists('sizeclass')) {
	function sizeclass($imgsize) {
		if ($imgsize == 't')
			return ' size-thumbnail';
		else if ($imgsize == 100)
			return ' size-small';
		else if ($imgsize == 240)
			return ' size-medium';
		else if ($imgsize == 1024)
			return ' size-large';
		else
			return;
	}
}



if ($instance['defaultcss'] == 'y')
	$default = ' iperssdefault';
if ($instance['customcss'] == 'y')
	$custom = ' ipersscustom';


$ret = ''; # return value
$item = $instance['item'];
$output = 'empty';

if ( ($instance['item']) || ($instance['type'] == 'all') ) {
	if ($instance['type'] == 'user') {
		$uri = 'http://api.ipernity.com/feed/doc?user_id='.$item;
	}
	elseif ($instance['type'] == 'album') {
		$uri = 'http://api.ipernity.com/feed/doc?album_id='.$item;
	}
	elseif ($instance['type'] == 'owntag') {
		$data = explode(',', $item);
		$uri = 'http://api.ipernity.com/feed/doc?user_id='.
			$data[0].'&keywords=%22'.$data[1].'%22';
	}
	elseif ($instance['type'] == 'globaltag') {
		$uri = 'http://api.ipernity.com/feed/doc?keywords="'.$item.'"';
	}
	elseif ($instance['type'] == 'group') {
		$uri = 'http://api.ipernity.com/feed/doc?group_id='.$item;
	}
	elseif ($instance['type'] == 'all') {
		$uri = 'http://api.ipernity.com/feed/doc?void=void';
	}
	else {
		$errormsg = '<p>'.$typeerror.'</p>';
		$uri = 'http://api.ipernity.com/feed/doc?'.
		'user_id=hopefullyinvalid2343467thFY345456FGHFGH';
		$output = false;
	}
	
	if ( ($f = fetch_feed($uri.'&format=rss&lang='.$instance['lang']))
		&& ($output == 'empty') ) {
		$output = true;
		if ($f->get_link() == 'http://www.ipernity.com/help/feeds') {
			$errormsg = '<p>'.$itemerror.'</p>';
			$output = false;
		}
		$link = $f->get_link();
		$item = $f->get_title();
	}
}
else {
	$errormsg = '<p>'.$noitemerror.'</p>';
	$output = false;
}


if (strlen($instance['addclass']) >= 1) {
	$addclass = ' class="'.$instance['addclass'].'"';
}


if (!$instance['display']) {
	$display = ' widget';
}
else {
	$display = ' '.$instance['display'];
	$showtitle = true;
}


$ret .= '<div class="iperssdiv'.$default.$custom.$display.
	sizeclass($instance['imgsize']).'"><ul'.$addclass.'>';


if($output == true) {
	if ($showtitle == true) {
		$ret .= '<li class="ipersstitle"><h2>'.
			$instance['title'].'</h2></li>';
	}
	$ret .= '<li class="iperssitem"><a href="'.$link.'">'.$item.'</a></li>';
	foreach ($f->get_items(0, $instance['number']) as $feeditem) {
		$title = str_replace(array('&lt;','&gt;'),'',
			$feeditem->get_title());
		$date = $feeditem->get_date($instance['datefmt']);
		$tn = gettn($feeditem, $instance['imgsize']);
		$link = $feeditem->get_link();
		$ret .= '<li class="iperssimg">'.
			'<h3>'.$title.'</h3>'.
			'<a href="'.$link.'">'.
			'<img src="'.$tn.'" title="'.$title.'" '.
			'alt="'.$title.'"/></a>'.
			'<em>'.__($date).'</em>'.
			'</li>';
	}
}
else {
	if (!$errormsg) {
		$errormsg = '<p>'.$unhandlederror.'</p>';
	}
	$ret .= '<li class="ipersserror">'.$errormsg.'</li>';

}


$ret .= '<li class="iperssclearfix"></li>';
if ($instance['poweredby'] == true) {
	$ret .= '<li class="iperssinfo"><a href="http://iperss.0x7be.de">'.
		$poweredbylink.'</a></li>';
}
$ret .= '</ul></div>';


?>
