<?php

# i18n

$title = __('ipeRSS Function Help', 'iperss');

$intro1 = __('By using the ipeRSS template tag (i.e. PHP function) you can add an ipeRSS instance in your WordPress theme wherever you want. Below is a list of options that can be used for calling the function. The names and descriptions are identical to the shortcode parameter names and description.', 'iperss');
$intro2 = __('Because it’s likely that you’re familiar with using PHP functions in WordPress themes there is no description on this …', 'iperss');
$intro3 = __('', 'iperss');

$infotable = __('Descriptions', 'iperss');

$examplestitle = __('Function usage examples', 'iperss');

$examplesinfo = __('All parameters have to be provided in an associative array. Except the item. The item has to be the first parameter and has to be a string.', 'iperss');

$examplesoutrotext = __('The function name is %s and should not interfere with other plugins. Please tell me if it does.', 'iperss');
$examplesoutro = sprintf($examplesoutrotext, '<code>iperss()</code>');


?>

<div class="wrap">
<div id="icon-options-general" class="icon32"><br /></div>
<h2><?php echo $title; ?></h2>



<p>
<?php
echo '<p>'.$intro1.'</p>';
echo '<p>'.$intro2.'</p>';
?>
</p>



<h3 class="ipersscodeshelp"><?php echo $infotable; ?></h3>

<?php include('codes.inc.php'); ?>



<h3 class="ipersscodeshelp"><?php echo $examplestitle; ?></h3>
<p><?php echo $examplesinfo; ?></p>

<ul class="iperssfunctionexamples">
<?php
function li($example) {
	echo '<li><div class="iperssfunctionexamplecode">'.
		'<pre>&lt;?php'.$example.'?&gt;</pre></div></li>';
}

$item = __('ITEM', 'iperss');

li(' iperss(\''.$item.'\'); ');
li(' iperss(\''.$item.'\', array(\'addclass\'=>\''.
	__('bar', 'iperss').'\')); ');
li("\n".
	'    $opts = array('."\n".
	'            \'number\'=>10 '."\n".
	'            \'lang\'=>\'en\' '."\n".
	'            \'customcss\'=>true '."\n".
	'    )'."\n".
	'    iperss(\''.$item.'\', $opts);'.
	"\n");
li("\n".
	'    $f[\'type\'] = \'owntag\''."\n".
	'    $f[\'imgsize\'] = \'m\''."\n".
	'    $f[\'poweredby\'] = \'true\''."\n".
	'    iperss(\''.$item.'\', $f);'.
	"\n")
?>
</ul>
<p><?php echo $examplesoutro; ?></p>

</div>
