<?php

function iperss_shortcode($instance) {
	$def = array(
		'title' => __('ipeRSS', 'iperss'),
		'number' => 6,
		'item' => '',
		'type' => 'user',
		'lang' => 'en',
		'imgsize' => 't',
		'datefmt' => 'Y-m-d\TH:i:s',
		'customcss' => '',
		'loggedin' => false,
		'defaultcss' => true,
		'poweredby' => false,
		'addclass' => false,
		'marginforcefix' => false
	);


	$instance = shortcode_atts($def, $instance);

	# TODO: uncomment before release
	#print_r($instance);

	# Logged in users only?
	if ( !is_user_logged_in() and $instance['loggedin'] ) {
		return;
	}

	# imgsize fixes
	if ($instance['imgsize'] == 't')
		$instance['imgsize'] = 't';
	elseif ($instance['imgsize'] == 's')
		$instance['imgsize'] = 100;
	elseif ($instance['imgsize'] == 'm')
		$instance['imgsize'] = 240;
	elseif ($instance['imgsize'] == 'l')
		$instance['imgsize'] = 1024;
	else
		$instance['imgsize'] = 100;

	# Yes, false and true are strings in this case!
	if ($instance['customcss'] == 'true')
		$instance['customcss'] = 'y';
	if ($instance['defaultcss'] != 'false')
		$instance['defaultcss'] = 'y';

	# Apply margin fix for some themes
	if ($instance['marginforcefix']) {
		$instance['display'] = 'shortcode marginforcefix';
	}
	else {
		$instance['display'] = 'shortcode';
	}
	include('iperss.php');
	return $ret;
}


add_shortcode('iperss', 'iperss_shortcode');

?>
